package com.proximity.demo.eventbriteApi.Subcategories;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.proximity.demo.eventbriteApi.Categories.Category;
import com.proximity.demo.eventbriteApi.Events.Event;

import javax.persistence.*;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

@Entity
@JsonIgnoreProperties(ignoreUnknown = true)
@Table(name="Subcategories")
public class Subcategory {

    @Id
    @Column(unique = true)
    private long id;
    private String name;
    private int parent_id;

//    @OneToMany(mappedBy = "subcategory_id")
//    private Set<Event> event = new HashSet<>();


    public Subcategory() {}

    public Subcategory(long id, String name, int parent_id, Set<Event> event) {
        this.id = id;
        this.name = name;
        this.parent_id = parent_id;
//        this.event = event;
//        this.category = category;
    }

    @JsonProperty("parent_category")
    private void unpackParentCategory(Map<String, Object> parent_category) {
        this.parent_id = Integer.valueOf((String)parent_category.get("id"));
    }

//    @ManyToOne(fetch = FetchType.EAGER)
//    @JoinColumn(name = "parent_id")
//    private Category category;



    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getParent_id() {
        return parent_id;
    }

    public void setParent_id(int parent_id) {
        this.parent_id = parent_id;
    }


//    public Set<Event> getEvent() {
//        return event;
//    }
//
//    public void setEvent(Set<Event> event) {
//        this.event = event;
//    }

    @Override
    public String toString() {
        return "Subcategory{" +
                ", id=" + id +
                ", name='" + name + '\'' +
                ", parent_id=" + parent_id +
//                ", event=" + event +
                '}';
    }
}
