package com.proximity.demo.eventbriteApi.Venues;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.scheduling.annotation.Async;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;
import java.util.Locale;
import java.util.Optional;

@RestController
@CrossOrigin
public class VenueController {

    @Autowired
    private VenueService venueService;

    @Autowired
    private VenueRepository venueRepository;

    @GetMapping("/v")
    public Venue get() {
        return venueService.getEventV();
    }
//
//    @Async
//    @GetMapping("/venues")
//    public Venue getAll() {
//        return venueService.getVenue();
//    }

//    @GetMapping("/venue/category/{category_id}/{start_date}")
//    public List<Venue> getVenues(
//            @PathVariable(value="category_id") long category_id,
//            @PathVariable(value="start_date") String start_date) {
//        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd", Locale.US);
//        LocalDate dateTime = LocalDate.parse(start_date, formatter);
//
//        return venueRepository.findByCategory(category_id, dateTime);
//    }
    @GetMapping("/venue/category/{category_id}/{input_start_date}")
    public List<Venue> getVenues(
        @PathVariable(value="category_id") long category_id,
        @PathVariable(value="input_start_date") String input_start_date) {
    return venueRepository.findByCategory(category_id, input_start_date);
}

    @GetMapping("/venue/category/{category_id}")
    public List<Venue> getVenues2(
            @PathVariable(value="category_id") long category_id) {
        return venueRepository.findByCategoryId(category_id);
    }

    @GetMapping("/venue")
    public List<Venue> getVenue() {
        return venueRepository.findAll();
    }

    @GetMapping("/venues/{id}")
    public Optional<Venue> get(@PathVariable long id) {
        System.out.println(id);
        System.out.println(venueRepository.findByName("Monumental Baptist Church"));
        return venueRepository.findById(id);
    }

}
