package com.proximity.demo.eventbriteApi.Venues;

import com.proximity.demo.eventbriteApi.Events.Event;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

@Repository
public interface VenueRepository extends JpaRepository<Venue, Long> {

    Venue findByName(String name);

//    @Query("select v from Venue v join v.event as e where e.category_id = ?1 AND CAST(start_date as date) = DATE_FORMAT('%Y-%m-%d')")
//    List<Venue> findByCategory(long category_id, LocalDate start_Date);

//    @Query("select v from Venue v join v.event as e where e.category_id = ?1 AND input_start_date = DATE_FORMAT(e.start_date, '%Y-%m-%d')")
    @Query("select v from Venue v join v.event as e where e.category_id = ?1 AND DATE_FORMAT(e.start_date, '%Y-%m-%d') = ?2")
    List<Venue> findByCategory(long category_id, String input_start_date);

    @Query("select v from Venue v join v.event as e where e.category_id =?1")
    List<Venue> findByCategoryId(long category_id);

}
