package com.proximity.demo.eventbriteApi.Venues;

import com.proximity.demo.eventbriteApi.Events.Event;
import com.proximity.demo.eventbriteApi.Events.EventRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.web.client.RestTemplateBuilder;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.List;

@Service
public class VenueService {

    private static final String token = "FW5VNKL6N5VMXKQO7TFV";
    private final RestTemplate restTemplate;
    private Venue venue = new Venue();
    private EventRepository eventRepository;
    private VenueRepository venueRepository;

    @Autowired
    public VenueService(RestTemplateBuilder restTemplateBuilder, EventRepository eventRepository, VenueRepository venueRepository) {
        this.restTemplate = restTemplateBuilder.build();
        this.eventRepository = eventRepository;
        this.venueRepository = venueRepository;
    }

    public Venue getEventV() {
        String url = "https://www.eventbriteapi.com/v3/venues/15846940"
                + "?token=" + token;
        Venue venue = restTemplate.getForObject(url, Venue.class);
        venueRepository.save(venue);
        return null;
    }

    @Async
    public Venue getEventVenue(){
        List<Event> events = eventRepository.findAll();
        for(Event event : events) {
            Long venue_id = event.getVenue_id();
            String url = "https://www.eventbriteapi.com/v3/venues/"
                    + venue_id
                    + "?token=" + token;
            Venue venue = restTemplate.getForObject(url, Venue.class);
            venueRepository.save(venue);
        }
        return null;
    }

//    public Venue getVenue(){
//    List<Event> events = eventRepository.findAll();
//    for(int i = 1475; i < events.size(); i++) {
//        Long venue_id = events.get(i).getVenue_id();
//        String url = "https://www.eventbriteapi.com/v3/venues/"
//                + venue_id
//                + "?token=" + token;
//        Venue venue = restTemplate.getForObject(url, Venue.class);
//        venueRepository.save(venue);
//        }
//        return null;
//    }

    private Venue save(Venue venue) { return this.venueRepository.save(venue); }

    public Venue find(String name) { return this.venueRepository.findByName(venue.getName()); }
}
